<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui"><title>Spring: Thymeleaf šablony</title><meta name="author" content="Jan Kolomazník"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/reset.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/reveal.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/theme/blood.css" id="theme"><!--This CSS is generated by the Asciidoctor reveal.js converter to further integrate AsciiDoc's existing semantic with reveal.js--><style type="text/css">.reveal div.right{float:right}

/* listing block */
.reveal .listingblock.stretch>.content{height: 100%}
.reveal .listingblock.stretch>.content>pre{height: 100%}
.reveal .listingblock.stretch>.content>pre>code{height:100%;max-height:100%}

/* tables */
table{border-collapse:collapse;border-spacing:0}
table{margin-bottom:1.25em;border:solid 1px #dedede}
table thead tr th,table thead tr td,table tfoot tr th,table tfoot tr td{padding:.5em .625em .625em;font-size:inherit;text-align:left}
table tr th,table tr td{padding:.5625em .625em;font-size:inherit}
table thead tr th,table tfoot tr th,table tbody tr td,table tr td,table tfoot tr td{display:table-cell;line-height:1.6}
td.tableblock>.content{margin-bottom:1.25em}
td.tableblock>.content>:last-child{margin-bottom:-1.25em}
table.tableblock,th.tableblock,td.tableblock{border:0 solid #dedede}
table.grid-all>thead>tr>.tableblock,table.grid-all>tbody>tr>.tableblock{border-width:0 1px 1px 0}
table.grid-all>tfoot>tr>.tableblock{border-width:1px 1px 0 0}
table.grid-cols>*>tr>.tableblock{border-width:0 1px 0 0}
table.grid-rows>thead>tr>.tableblock,table.grid-rows>tbody>tr>.tableblock{border-width:0 0 1px}
table.grid-rows>tfoot>tr>.tableblock{border-width:1px 0 0}
table.grid-all>*>tr>.tableblock:last-child,table.grid-cols>*>tr>.tableblock:last-child{border-right-width:0}
table.grid-all>tbody>tr:last-child>.tableblock,table.grid-all>thead:last-child>tr>.tableblock,table.grid-rows>tbody>tr:last-child>.tableblock,table.grid-rows>thead:last-child>tr>.tableblock{border-bottom-width:0}
table.frame-all{border-width:1px}
table.frame-sides{border-width:0 1px}
table.frame-topbot,table.frame-ends{border-width:1px 0}
.reveal table th.halign-left,.reveal table td.halign-left{text-align:left}
.reveal table th.halign-right,.reveal table td.halign-right{text-align:right}
.reveal table th.halign-center,.reveal table td.halign-center{text-align:center}
.reveal table th.valign-top,.reveal table td.valign-top{vertical-align:top}
.reveal table th.valign-bottom,.reveal table td.valign-bottom{vertical-align:bottom}
.reveal table th.valign-middle,.reveal table td.valign-middle{vertical-align:middle}
table thead th,table tfoot th{font-weight:bold}
tbody tr th{display:table-cell;line-height:1.6}
tbody tr th,tbody tr th p,tfoot tr th,tfoot tr th p{font-weight:bold}
thead{display:table-header-group}

.reveal table.grid-none th,.reveal table.grid-none td{border-bottom:0!important}

/* kbd macro */
kbd{font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;display:inline-block;color:rgba(0,0,0,.8);font-size:.65em;line-height:1.45;background:#f7f7f7;border:1px solid #ccc;-webkit-border-radius:3px;border-radius:3px;-webkit-box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em white inset;box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em #fff inset;margin:0 .15em;padding:.2em .5em;vertical-align:middle;position:relative;top:-.1em;white-space:nowrap}
.keyseq kbd:first-child{margin-left:0}
.keyseq kbd:last-child{margin-right:0}

/* callouts */
.conum[data-value] {display:inline-block;color:#fff!important;background:rgba(0,0,0,.8);-webkit-border-radius:50%;border-radius:50%;text-align:center;font-size:.75em;width:1.67em;height:1.67em;line-height:1.67em;font-family:"Open Sans","DejaVu Sans",sans-serif;font-style:normal;font-weight:bold}
.conum[data-value] *{color:#fff!important}
.conum[data-value]+b{display:none}
.conum[data-value]:after{content:attr(data-value)}
pre .conum[data-value]{position:relative;top:-.125em}
b.conum *{color:inherit!important}
.conum:not([data-value]):empty{display:none}
/* Callout list */
.hdlist>table,.colist>table{border:0;background:none}
.hdlist>table>tbody>tr,.colist>table>tbody>tr{background:none}
td.hdlist1,td.hdlist2{vertical-align:top;padding:0 .625em}
td.hdlist1{font-weight:bold;padding-bottom:1.25em}
/* Disabled from Asciidoctor CSS because it caused callout list to go under the
 * source listing when .stretch is applied (see #335)
 * .literalblock+.colist,.listingblock+.colist{margin-top:-.5em} */
.colist td:not([class]):first-child{padding:.4em .75em 0;line-height:1;vertical-align:top}
.colist td:not([class]):first-child img{max-width:none}
.colist td:not([class]):last-child{padding:.25em 0}

/* Override Asciidoctor CSS that causes issues with reveal.js features */
.reveal .hljs table{border: 0}
/* Callout list rows would have a bottom border with some reveal.js themes (see #335) */
.reveal .colist>table th, .reveal .colist>table td {border-bottom:0}
/* Fixes line height with Highlight.js source listing when linenums enabled (see #331) */
.reveal .hljs table thead tr th, .reveal .hljs table tfoot tr th, .reveal .hljs table tbody tr td, .reveal .hljs table tr td, .reveal .hljs table tfoot tr td{line-height:inherit}

/* Columns layout */
.columns .slide-content {
  display: flex;
}

.columns.wrap .slide-content {
  flex-wrap: wrap;
}

.columns.is-vcentered .slide-content {
  align-items: center;
}

.columns .slide-content > .column {
  display: block;
  flex-basis: 0;
  flex-grow: 1;
  flex-shrink: 1;
  padding: .75rem;
}

.columns .slide-content > .column.is-full {
  flex: none;
  width: 100%;
}

.columns .slide-content > .column.is-four-fifths {
  flex: none;
  width: 80%;
}

.columns .slide-content > .column.is-three-quarters {
  flex: none;
  width: 75%;
}

.columns .slide-content > .column.is-two-thirds {
  flex: none;
  width: 66.6666%;
}

.columns .slide-content > .column.is-three-fifths {
  flex: none;
  width: 60%;
}

.columns .slide-content > .column.is-half {
  flex: none;
  width: 50%;
}

.columns .slide-content > .column.is-two-fifths {
  flex: none;
  width: 40%;
}

.columns .slide-content > .column.is-one-third {
  flex: none;
  width: 33.3333%;
}

.columns .slide-content > .column.is-one-quarter {
  flex: none;
  width: 25%;
}

.columns .slide-content > .column.is-one-fifth {
  flex: none;
  width: 20%;
}
</style><link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.12.0-1/css/all.min.css"><link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.12.0-1/css/v4-shims.min.css"><!--Printing and PDF exports--><script>var link = document.createElement( 'link' );
link.rel = 'stylesheet';
link.type = 'text/css';
link.href = window.location.search.match( /print-pdf/gi ) ? "https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/print/pdf.css" : "https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/print/paper.css";
document.getElementsByTagName( 'head' )[0].appendChild( link );</script></head><body><div class="reveal"><div class="slides"><section class="title" data-state="title"><h1>Spring</h1><h2>Thymeleaf šablony</h2><p class="author"><small>Jan Kolomazník</small></p></section><section><section id="_co_je_thymeleaf"><h2>Co je Thymeleaf?</h2><div class="slide-content"><div class="paragraph"><p>Thymeleaf je moderní javovský šablonovací systém.</p></div><div class="paragraph"><p>Jedná se o open-source software vytvořený roku 2011 španělským inženýrem Danielem Fernándezem a v současnosti udržovaný týmem nadšenců.</p></div><div class="paragraph"><p>Dobře si rozumí s frameworkem Spring kde jej lze snadno využít v pohledové vrstvě jako plnohodnotnou náhradu JSP (umožňují vkládání Java kódu do HTML).</p></div><div class="paragraph"><p>Mezi přednosti systému Thymeleaf patří elegantní syntaxe, konfigurovatelnost a extrémní rozšiřitelnost umožňující ovlivnit zpracování šablon do nejmenších detailů.</p></div><div class="paragraph"><p>Dalšími alternativami šablonovácích systémů pro framework Spring jsou například Apache Velocity nebo FreeMaker.</p></div><div class="paragraph"><p>Thymeleaf umožňuje zpracovávat 6 druhů šablon: HTML, XML, TEXT, JAVASCRIPT, CSS a RAW.</p></div><div class="paragraph"><p>Thymeleaf je aktuálně dostupný ve verzi 3.0.11.</p></div><div class="paragraph"><p><a href="https://www.thymeleaf.org/doc/tutorials/3.0/usingthymeleaf.html">Dokumentace šablonovacího systému Thymeleaf</a></p></div></div></section><section id="_co_thymeleaf_není"><h2>Co Thymeleaf není?</h2><div class="slide-content"><div class="paragraph"><p>Není to webový framework, je to pouze do něj integrovaná součást.</p></div>
<div class="paragraph"><p>Mnoho frameworků má svůj vlastní šablonovací systém.</p></div>
<div class="paragraph"><p>Šablonovací systém se stará o pohledovou vrstvu.</p></div>
<div class="paragraph"><p>Vytvořená šablona doplněná o data tvoří finální dokument, který je zobrazen uživateli.</p></div>
<div class="paragraph"><p>Příklad: <code>${user.name}</code> → Jan Novák</p></div></div></section><section id="_klíčové_vlastnosti"><h2>Klíčové vlastnosti</h2><div class="slide-content"><div class="ulist"><ul><li><p>primárně určený pro Java webové aplikace</p></li><li><p>využívá DOM</p></li><li><p>lze jej použít na webu i pro offline dokumenty (email, XML data)</p></li><li><p>vytváří XML, XHTML nebo HTML5</p></li><li><p>vyhodnocování výrazů, internacionalizace, přepis URL</p></li><li><p>konfigurovatelný a rozšiřitelný</p></li><li><p>možnosti statického prototypování - nový přístup</p></li></ul></div></div></section><section id="_natural_templating"><h2>Natural templating</h2><div class="slide-content"><div class="paragraph"><p>Tento princip je využíván systémem Thymeleaf.</p></div>
<div class="paragraph"><p>Podle něj musí být šablona stejně validní jako finální dokument.</p></div>
<div class="paragraph"><p>To znamená že syntaxe pro šablonovací engine nenarušuje strukturu dokumentu.</p></div>
<div class="paragraph"><p>Celá šablona je díky tomu staticky zobrazitelná - funguje jako designový prototyp.</p></div>
<div class="paragraph"><p>Těchto vlastností je dosaženo používáním vlastních atributů, které prohlížeče ignorují a vyvarováním se výrazů v tělech tagů.</p></div>
<div class="paragraph"><p>Na obrázcích níže je k vidění rozdíl ve statickém zobrazení dokumentu vytvořeného pomocí Thymeleaf oproti šabloně vytvořené pomocí JSP.</p></div>
<h3>Natural templating - Thymeleaf</h3><div class="paragraph"><p><span class="image"><img src="https://www.thymeleaf.org/doc/articles/images/thvsjsp/th1.png" alt="alt text"></span></p></div>
<h3>Natural templating - JSP</h3><div class="paragraph"><p><span class="image"><img src="https://www.thymeleaf.org/doc/articles/images/thvsjsp/jsp3.png" alt="alt text"></span></p></div></div></section></section>
<section><section id="_the_standard_dialect"><h2>The Standard Dialect</h2><div class="slide-content"><div class="paragraph"><p>Objekt, který přidává tagu nějakou logiku se nazývá processor.</p></div><div class="paragraph"><p>V Thymeleaf je většina processorů atributová.</p></div><div class="paragraph"><p>Skupina těchto processorů je pak nazývána jako dialect.</p></div><div class="paragraph"><p>Jádro systému Thymeleaf poskytuje tzv. Standard Dialect, který by měl svými funkcemi většině uživatelů zcela dostačovat.</p></div><div class="paragraph"><p><strong>Vybrané funkce:</strong></p></div><div class="ulist"><ul><li><p>výrazy <code>${proměnná}</code> pro výpis proměnné a <code>*{proměnná}</code> pro zápis do ní</p></li><li><p>přístup k beanám v aplikaci pomocí <code>${myBean.doSomething()}</code></p></li><li><p>Thymeleaf atributy pro formuláře:</p><div class="ulist"><ul><li><p><code>th:field</code></p></li><li><p><code>th:errors</code></p></li><li><p><code>th:errorclass</code></p></li><li><p><code>th:object</code></p></li></ul></div></li></ul></div><div class="paragraph"><p>V případě pokročilých požadavků na integraci do Springu lze vytvořit novou instanci template enginu, která automaticky provede požadovanou konfiguraci.</p></div></div></section><section id="_základní_konstrukty"><h2>Základní konstrukty</h2><div class="slide-content"><div class="paragraph"><p>Konstrukty Thymeleafu se přidávají principiálně přidáním atributů s prefixem <code>th:</code> do HTML tagů.</p></div>
<div class="paragraph"><p>Hodnoty z langtext souborů (pozn. langtext soubory umožňují uložit vkládaný text mimo šablonu) se vkládají pomocí <code>#{nazev.vlastnost}</code>, hodnoty z proměnných se vkládají pomocí <code>${nazevPromenne}.</code></p></div>
<h3>Ukázka - Podmíněné zobrazení elementu s textem</h3><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="html" class="language-html hljs" data-noescape="true">&lt;div  th:if=”${hodnota == 100}” th:text=”${name}”&gt;původní text&lt;/div&gt;</code></pre></div></div>
<h3>Příklad použití šablonovacího systému</h3><div class="ulist"><ul><li><p><strong>Zavislosti</strong></p></li><li><p>do souboru <code>build.gradle</code></p></li><li><p>přidáme dependency <code>implementation("org.springframework.boot:spring-boot-starter-thymeleaf")</code></p></li><li><p>ve složce resources vytvoříme složky <code>static</code> a <code>templates</code></p></li><li><p>do složky templates vytvoříme soubor <code>greeting.html</code></p></li><li><p>vytvoříme package person a třídu <code>PersonController</code></p></li></ul></div>
<div class="listingblock"><div class="content"><pre>@Controller
public class PersonController {

    @GetMapping("/")
    public String welcome(Map&lt;String, Object&gt; model){
        model.put("greeting", "Hello world!");
        return "greeting";
    }
}</pre></div></div>
<h3>Příklad použití šablonovacího systému</h3><div class="ulist"><ul><li><p>Do souboru šablony můžeme zatím použít tento kód</p></li></ul></div>
<div class="listingblock"><div class="content"><pre>&lt;!DOCTYPE html&gt;
&lt;html xmlns:th="http://www.thymeleaf.org"&gt;
&lt;head&gt;
    &lt;meta charset="UTF-8"&gt;
    &lt;title&gt;Welcome&lt;/title&gt;
    &lt;link rel="stylesheet"
          href="../../static/css/bootstrap.min.css"
          th:href="@{/css/bootstrap.css}"/&gt;
    &lt;link rel="stylesheet"
          href="../../static/css/main.css"
          th:href="@{/css/main.css}"/&gt;
&lt;/head&gt;
&lt;body&gt;
    &lt;h1 th:text="${greeting}"&gt;&lt;/h1&gt;
&lt;/body&gt;
&lt;/html&gt;</pre></div></div>
<div class="ulist"><ul><li><p>Spustíme aplikaci</p></li></ul></div>
<h3>Příklad formuláře pro přidání osoby</h3><div class="ulist"><ul><li><p>Vytvoříme třídu Person</p></li></ul></div>
<div class="listingblock"><div class="content"><pre>@Data
public class Person {
        private String name;
        private String surname;
}</pre></div></div>
<div class="ulist"><ul><li><p>Vytvoříme potřebné metody v PersonControlleru</p></li></ul></div>
<div class="listingblock"><div class="content"><pre>@GetMapping("/form")
public String form(Map&lt;String, Object&gt; model){
    model.put("person", new Person());
    return "form";
}

@PostMapping("/sendForm")
public String formSubmit(
        @ModelAttribute Person person,
        Map&lt;String, Object&gt; model
){
    model.put("person", person);
    return "result";
}</pre></div></div>
<h3>Příklad formuláře pro přidání osoby</h3><div class="ulist"><ul><li><p>Vytvoříme HTML stránku form.html</p></li></ul></div>
<div class="listingblock"><div class="content"><pre>&lt;!DOCTYPE html&gt;
&lt;html xmlns:th="http://www.thymeleaf.org"&gt;
&lt;head&gt;
    &lt;!-- Header definition --&gt;
&lt;/head&gt;
&lt;body&gt;
    &lt;div class="container"&gt;
        &lt;form method="post"
              th:action="@{/sendForm}"
              th:object="${person}"&gt;
            &lt;div class="form-group"&gt;
                &lt;label for="name"&gt;Jméno&lt;/label&gt;
                &lt;input type="text"
                       class="form-control"
                       id="name"
                       th:field="*{name}"&gt;
                &lt;label for="surname"&gt;Příjmení&lt;/label&gt;
                &lt;input type="text"
                       class="form-control"
                       id="surname"
                       th:field="*{surname}"&gt;
            &lt;/div&gt;
            &lt;button type="submit" class="btn btn-default"&gt;Odeslat&lt;/button&gt;
        &lt;/form&gt;
    &lt;/div&gt;
&lt;/body&gt;
&lt;/html&gt;</pre></div></div>
<h3>Příklad formuláře pro přidání osoby</h3><div class="ulist"><ul><li><p>Vytvoříme HTML stránku result.html</p></li></ul></div>
<div class="listingblock"><div class="content"><pre>&lt;!DOCTYPE html&gt;
&lt;html xmlns:th="http://www.thymeleaf.org"&gt;
&lt;head&gt;
    &lt;!-- Header definition --&gt;
&lt;/head&gt;
&lt;body&gt;
    &lt;div class="container"&gt;
        &lt;h1&gt;Vloženo&lt;/h1&gt;
        &lt;p th:text="${person.getName() + ' ' + person.getSurname()}"&gt;&lt;/p&gt;
        &lt;a th:href="@{/form}"&gt;Zpět na formulář&lt;/a&gt;
    &lt;/div&gt;
&lt;/body&gt;
&lt;/html&gt;</pre></div></div>
<div class="ulist"><ul><li><p>Spustíme aplikaci</p></li></ul></div></div></section><section id="_funkce_pro_tvorbu_šablon"><h2>Funkce pro tvorbu šablon</h2><div class="slide-content"><h3>Zápis textu</h3><div class="ulist"><ul><li><p><code>th:text=&quot;HTML escapovaný text (výchozí)&quot;</code></p></li><li><p><code>th:utext=&quot;neescapovaný text&quot;</code></p></li></ul></div>
<h3>Formátování</h3><div class="paragraph"><p><code>#dates</code>, <code>#calendars</code>, <code>#numbers</code>, <code>#strings</code></p></div>
<div class="paragraph"><p>a další … (<a href="https://www.thymeleaf.org/doc/tutorials/3.0/usingthymeleaf.html" class="bare">https://www.thymeleaf.org/doc/tutorials/3.0/usingthymeleaf.html</a>)</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="html" class="language-html hljs" data-noescape="true">&lt;dd th:text="${#dates.format(product.availableFrom, 'dd-MM-yyyy')}"&gt;
    28-Jun-2018
&lt;/dd&gt;</code></pre></div></div>
<h3>URL adresy</h3><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="html" class="language-html hljs" data-noescape="true">&lt;a th:href="@{/product.action(id=${product.id})}"&gt;View product&lt;/a&gt;</code></pre></div></div>
<div class="paragraph"><p>vytvoří</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="html" class="language-html hljs" data-noescape="true">&lt;a href="/myAppContext/product.action?id=264"&gt;View product&lt;/a&gt;</code></pre></div></div>
<h3>Iterace</h3><div class="paragraph"><p><strong>Each:</strong></p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="html" class="language-html hljs" data-noescape="true">&lt;tr th:each="product : ${productList}"&gt;
    &lt;td th:text="${productStat.count}"&gt;1&lt;/td&gt;  &lt;!-- číslo iterace --&gt;
    &lt;td th:text="${product.description}"&gt;Red chair&lt;/td&gt;
    &lt;td th:text="${product.price}"&gt;350 €&lt;/td&gt;
&lt;/tr&gt;</code></pre></div></div>
<h3>Podmínky</h3><div class="paragraph"><p><strong>If:</strong></p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="html" class="language-html hljs" data-noescape="true">&lt;span th:if="${product.price lt 100}"&gt;Special offer!&lt;/span&gt;</code></pre></div></div>
<div class="paragraph"><p><strong>Unless:</strong></p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="html" class="language-html hljs" data-noescape="true">&lt;span th:unless="${product.notInStock}"&gt;Currently in stock!&lt;/span&gt;</code></pre></div></div>
<div class="paragraph"><p><strong>Switch/case:</strong></p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="html" class="language-html hljs" data-noescape="true">&lt;div th:switch="${user.role}"&gt;
    &lt;p th:case="'admin'"&gt;User is an administrator&lt;/p&gt;
    &lt;p th:case="#{roles.manager}"&gt;User is a manager&lt;/p&gt;
    &lt;p th:case="*"&gt;User is something other&lt;/p&gt;
&lt;/div&gt;</code></pre></div></div>
<h3>Formuláře a bean-binding</h3><div class="paragraph"><p><strong>th:object, th:field</strong></p></div>
<div class="paragraph"><p>Atribut <code>th-object</code> může být v celém formuláři pouze jednou a neakceptuje navigaci k jednotlivým atributům</p></div>
<div class="ulist"><ul><li><p>je třeba uvádět vždy celou proměnnou z modelu. Tzn. nelze psát <code>th:object=&quot;${property.data}&quot;</code></p></li><li><p>je nutné vložit celou proměnnou <code>th:object=&quot;${property}&quot;</code>.</p></li></ul></div>
<div class="paragraph"><p>Atribut <code>th-field</code> prováže hodnotu ve formuláři s proměnnou, je nutné zapisovat jako selektivní výraz <code>*{&#8230;&#8203;}</code>.</p></div></div></section><section id="_html_formuláře_a_bean_binding"><h2>HTML Formuláře a bean-binding</h2><div class="slide-content"><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="html" class="language-html hljs" data-noescape="true">&lt;form th:action="@{/saveCustomer}"
      th:object="${customer}"
      method="post"&gt;
    &lt;input type="hidden"
           th:field="*{id}" /&gt;

    &lt;label for="name"&gt;Name:&lt;/label&gt;
    &lt;input type="text"
           th:field="*{name}" /&gt;

    &lt;label for="countryId"&gt;Country:&lt;/label&gt;
    &lt;select th:field="*{countryId}"&gt;
        &lt;option th:each="country : ${allCountries}"
                th:value="${country.id}"
                th:text="${country.name}"&gt;Ireland&lt;/option&gt;
    &lt;/select&gt;

    &lt;input type="submit" /&gt;
&lt;/form&gt;</code></pre></div></div>
<div class="paragraph"><p><strong>Validace - podmíněné stylování</strong></p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="html" class="language-html hljs" data-noescape="true">&lt;input type="text"
       class="form-control"
       id="message"
       placeholder="enter text ..."
       th:field="*{message}"
       th:class="${#fields.hasErrors('message')}? fieldError"&gt;</code></pre></div></div>
<div class="paragraph"><p>Poznámka: V tomto případě lze s výhodou využít atribut <code>th:errorclass=&quot;fieldError&quot;</code></p></div>
<div class="paragraph"><p><strong>Iterace přes chyby</strong></p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="html" class="language-html hljs" data-noescape="true">&lt;ul&gt;
    &lt;li th:each="err : ${#fields.errors('message')}"
        th:text="${err}" /&gt;
&lt;/ul&gt;</code></pre></div></div></div></section><section id="_kompozice_stránky"><h2>Kompozice stránky</h2><div class="slide-content"><div class="paragraph"><p><strong>Deklarace fragmentu pomocí <code>th:fragment</code></strong></p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="html" class="language-html hljs" data-noescape="true">&lt;h2&gt;Product information&lt;/h2&gt;
&lt;div th:fragment="banner"&gt;
    &lt;img th:src="@{/logo.png}"
         alt="Some logo" /&gt;
&lt;/div&gt;</code></pre></div></div>
<div class="paragraph"><p><strong>Znovupoužití fragmentu pomocí <code>th:include</code></strong></p></div>
<div class="paragraph"><p>Při znovupoužití se vloží obsah mezi značkami, na kterých byl tento atribut definován.</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="html" class="language-html hljs" data-noescape="true">&lt;h2&gt;Product list&lt;/h2&gt;
&lt;div th:include="index.html::banner"&gt;Banner&lt;/div&gt;</code></pre></div></div>
<h3>Renderování fragmentů šablony</h3><div class="paragraph"><p>Thymeleaf nabízí možnost jako odpověď vygenerovat pouze fragment z pohledu.</p></div>
<div class="paragraph"><p>Lze to využít například pro přednostní zobrazení načtených komponent, zatímco ostatní se ještě načítají.</p></div>
<div class="paragraph"><p>Specifikace lze provést pomocí view-beans či přes návratovou hodnotu controlleru.</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="java" class="language-java hljs" data-noescape="true">@RequestMapping("/menu")
public String menu(Map&lt;String, Object&gt; model) {
    return "index :: menu";  //show only menu fragment
}</code></pre></div></div>
<h3>Inlining</h3><div class="paragraph"><p>Ačkoli je téměř vše možné vyřešit pomocí atributů tagů, někdy se může hodit vkládat výrazy přímo do HTML textu.</p></div>
<div class="paragraph"><p>Preferujeme</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="html" class="language-html hljs" data-noescape="true">&lt;p&gt;Hello, [[${session.user.name}]]!&lt;/p&gt;</code></pre></div></div>
<div class="paragraph"><p>před</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="html" class="language-html hljs" data-noescape="true">&lt;p&gt;Hello, &lt;span th:text="${session.user.name}"&gt;Sebastian&lt;/span&gt;!&lt;/p&gt;</code></pre></div></div></div></section></section></div></div><script src="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/js/reveal.js"></script><script>Array.prototype.slice.call(document.querySelectorAll('.slides section')).forEach(function(slide) {
  if (slide.getAttribute('data-background-color')) return;
  // user needs to explicitly say he wants CSS color to override otherwise we might break custom css or theme (#226)
  if (!(slide.classList.contains('canvas') || slide.classList.contains('background'))) return;
  var bgColor = getComputedStyle(slide).backgroundColor;
  if (bgColor !== 'rgba(0, 0, 0, 0)' && bgColor !== 'transparent') {
    slide.setAttribute('data-background-color', bgColor);
    slide.style.backgroundColor = 'transparent';
  }
});

// More info about config & dependencies:
// - https://github.com/hakimel/reveal.js#configuration
// - https://github.com/hakimel/reveal.js#dependencies
Reveal.initialize({
  // Display presentation control arrows
  controls: true,
  // Help the user learn the controls by providing hints, for example by
  // bouncing the down arrow when they first encounter a vertical slide
  controlsTutorial: true,
  // Determines where controls appear, "edges" or "bottom-right"
  controlsLayout: 'bottom-right',
  // Visibility rule for backwards navigation arrows; "faded", "hidden"
  // or "visible"
  controlsBackArrows: 'faded',
  // Display a presentation progress bar
  progress: true,
  // Display the page number of the current slide
  slideNumber: false,
  // Control which views the slide number displays on
  showSlideNumber: 'all',
  // Add the current slide number to the URL hash so that reloading the
  // page/copying the URL will return you to the same slide
  hash: false,
  // Push each slide change to the browser history. Implies `hash: true`
  history: false,
  // Enable keyboard shortcuts for navigation
  keyboard: true,
  // Enable the slide overview mode
  overview: true,
  // Vertical centering of slides
  center: false,
  // Enables touch navigation on devices with touch input
  touch: true,
  // Loop the presentation
  loop: false,
  // Change the presentation direction to be RTL
  rtl: false,
  // See https://github.com/hakimel/reveal.js/#navigation-mode
  navigationMode: 'default',
  // Randomizes the order of slides each time the presentation loads
  shuffle: false,
  // Turns fragments on and off globally
  fragments: true,
  // Flags whether to include the current fragment in the URL,
  // so that reloading brings you to the same fragment position
  fragmentInURL: false,
  // Flags if the presentation is running in an embedded mode,
  // i.e. contained within a limited portion of the screen
  embedded: false,
  // Flags if we should show a help overlay when the questionmark
  // key is pressed
  help: true,
  // Flags if speaker notes should be visible to all viewers
  showNotes: false,
  // Global override for autolaying embedded media (video/audio/iframe)
  // - null: Media will only autoplay if data-autoplay is present
  // - true: All media will autoplay, regardless of individual setting
  // - false: No media will autoplay, regardless of individual setting
  autoPlayMedia: null,
  // Global override for preloading lazy-loaded iframes
  // - null: Iframes with data-src AND data-preload will be loaded when within
  //   the viewDistance, iframes with only data-src will be loaded when visible
  // - true: All iframes with data-src will be loaded when within the viewDistance
  // - false: All iframes with data-src will be loaded only when visible
  preloadIframes: null,
  // Number of milliseconds between automatically proceeding to the
  // next slide, disabled when set to 0, this value can be overwritten
  // by using a data-autoslide attribute on your slides
  autoSlide: 0,
  // Stop auto-sliding after user input
  autoSlideStoppable: true,
  // Use this method for navigation when auto-sliding
  autoSlideMethod: Reveal.navigateNext,
  // Specify the average time in seconds that you think you will spend
  // presenting each slide. This is used to show a pacing timer in the
  // speaker view
  defaultTiming: 120,
  // Specify the total time in seconds that is available to
  // present.  If this is set to a nonzero value, the pacing
  // timer will work out the time available for each slide,
  // instead of using the defaultTiming value
  totalTime: 0,
  // Specify the minimum amount of time you want to allot to
  // each slide, if using the totalTime calculation method.  If
  // the automated time allocation causes slide pacing to fall
  // below this threshold, then you will see an alert in the
  // speaker notes window
  minimumTimePerSlide: 0,
  // Enable slide navigation via mouse wheel
  mouseWheel: false,
  // Hide cursor if inactive
  hideInactiveCursor: true,
  // Time before the cursor is hidden (in ms)
  hideCursorTime: 5000,
  // Hides the address bar on mobile devices
  hideAddressBar: true,
  // Opens links in an iframe preview overlay
  // Add `data-preview-link` and `data-preview-link="false"` to customise each link
  // individually
  previewLinks: false,
  // Transition style (e.g., none, fade, slide, convex, concave, zoom)
  transition: 'slide',
  // Transition speed (e.g., default, fast, slow)
  transitionSpeed: 'default',
  // Transition style for full page slide backgrounds (e.g., none, fade, slide, convex, concave, zoom)
  backgroundTransition: 'fade',
  // Number of slides away from the current that are visible
  viewDistance: 3,
  // Number of slides away from the current that are visible on mobile
  // devices. It is advisable to set this to a lower number than
  // viewDistance in order to save resources.
  mobileViewDistance: 3,
  // Parallax background image (e.g., "'https://s3.amazonaws.com/hakim-static/reveal-js/reveal-parallax-1.jpg'")
  parallaxBackgroundImage: '',
  // Parallax background size in CSS syntax (e.g., "2100px 900px")
  parallaxBackgroundSize: '',
  // Number of pixels to move the parallax background per slide
  // - Calculated automatically unless specified
  // - Set to 0 to disable movement along an axis
  parallaxBackgroundHorizontal: null,
  parallaxBackgroundVertical: null,
  // The display mode that will be used to show slides
  display: 'block',

  // The "normal" size of the presentation, aspect ratio will be preserved
  // when the presentation is scaled to fit different resolutions. Can be
  // specified using percentage units.
  width: 1250,
  height: 700,

  // Factor of the display size that should remain empty around the content
  margin: 0.1,

  // Bounds for smallest/largest possible scale to apply to content
  minScale: 0.2,
  maxScale: 1.5,

  // PDF Export Options
  // Put each fragment on a separate page
  pdfSeparateFragments: true,
  // For slides that do not fit on a page, max number of pages
  pdfMaxPagesPerSlide: 1,

  // Optional libraries used to extend on reveal.js
  dependencies: [
      { src: 'https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/plugin/zoom-js/zoom.js', async: true },
      { src: 'https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/plugin/notes/notes.js', async: true }
  ],

  

});</script><script>var dom = {};
dom.slides = document.querySelector('.reveal .slides');

function getRemainingHeight(element, slideElement, height) {
  height = height || 0;
  if (element) {
    var newHeight, oldHeight = element.style.height;
    // Change the .stretch element height to 0 in order find the height of all
    // the other elements
    element.style.height = '0px';
    // In Overview mode, the parent (.slide) height is set of 700px.
    // Restore it temporarily to its natural height.
    slideElement.style.height = 'auto';
    newHeight = height - slideElement.offsetHeight;
    // Restore the old height, just in case
    element.style.height = oldHeight + 'px';
    // Clear the parent (.slide) height. .removeProperty works in IE9+
    slideElement.style.removeProperty('height');
    return newHeight;
  }
  return height;
}

function layoutSlideContents(width, height) {
  // Handle sizing of elements with the 'stretch' class
  toArray(dom.slides.querySelectorAll('section .stretch')).forEach(function (element) {
    // Determine how much vertical space we can use
    var limit = 5; // hard limit
    var parent = element.parentNode;
    while (parent.nodeName !== 'SECTION' && limit > 0) {
      parent = parent.parentNode;
      limit--;
    }
    if (limit === 0) {
      // unable to find parent, aborting!
      return;
    }
    var remainingHeight = getRemainingHeight(element, parent, height);
    // Consider the aspect ratio of media elements
    if (/(img|video)/gi.test(element.nodeName)) {
      var nw = element.naturalWidth || element.videoWidth, nh = element.naturalHeight || element.videoHeight;
      var es = Math.min(width / nw, remainingHeight / nh);
      element.style.width = (nw * es) + 'px';
      element.style.height = (nh * es) + 'px';
    } else {
      element.style.width = width + 'px';
      element.style.height = remainingHeight + 'px';
    }
  });
}

function toArray(o) {
  return Array.prototype.slice.call(o);
}

Reveal.addEventListener('slidechanged', function () {
  layoutSlideContents(1250, 700)
});
Reveal.addEventListener('ready', function () {
  layoutSlideContents(1250, 700)
});
Reveal.addEventListener('resize', function () {
  layoutSlideContents(1250, 700)
});</script><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/lib/css/monokai.css"/>
<script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.18.1/highlight.min.js"></script>

<script>

/* highlightjs-line-numbers.js 2.6.0 | (C) 2018 Yauheni Pakala | MIT License | github.com/wcoder/highlightjs-line-numbers.js */
/* Edited by Hakim for reveal.js; removed async timeout */
!function(n,e){"use strict";function t(){var n=e.createElement("style");n.type="text/css",n.innerHTML=g(".{0}{border-collapse:collapse}.{0} td{padding:0}.{1}:before{content:attr({2})}",[v,L,b]),e.getElementsByTagName("head")[0].appendChild(n)}function r(t){"interactive"===e.readyState||"complete"===e.readyState?i(t):n.addEventListener("DOMContentLoaded",function(){i(t)})}function i(t){try{var r=e.querySelectorAll("code.hljs,code.nohighlight");for(var i in r)r.hasOwnProperty(i)&&l(r[i],t)}catch(o){n.console.error("LineNumbers error: ",o)}}function l(n,e){"object"==typeof n&&f(function(){n.innerHTML=s(n,e)})}function o(n,e){if("string"==typeof n){var t=document.createElement("code");return t.innerHTML=n,s(t,e)}}function s(n,e){e=e||{singleLine:!1};var t=e.singleLine?0:1;return c(n),a(n.innerHTML,t)}function a(n,e){var t=u(n);if(""===t[t.length-1].trim()&&t.pop(),t.length>e){for(var r="",i=0,l=t.length;i<l;i++)r+=g('<tr><td class="{0}"><div class="{1} {2}" {3}="{5}"></div></td><td class="{4}"><div class="{1}">{6}</div></td></tr>',[j,m,L,b,p,i+1,t[i].length>0?t[i]:" "]);return g('<table class="{0}">{1}</table>',[v,r])}return n}function c(n){var e=n.childNodes;for(var t in e)if(e.hasOwnProperty(t)){var r=e[t];h(r.textContent)>0&&(r.childNodes.length>0?c(r):d(r.parentNode))}}function d(n){var e=n.className;if(/hljs-/.test(e)){for(var t=u(n.innerHTML),r=0,i="";r<t.length;r++){var l=t[r].length>0?t[r]:" ";i+=g('<span class="{0}">{1}</span>\n',[e,l])}n.innerHTML=i.trim()}}function u(n){return 0===n.length?[]:n.split(y)}function h(n){return(n.trim().match(y)||[]).length}function f(e){e()}function g(n,e){return n.replace(/{(\d+)}/g,function(n,t){return e[t]?e[t]:n})}var v="hljs-ln",m="hljs-ln-line",p="hljs-ln-code",j="hljs-ln-numbers",L="hljs-ln-n",b="data-line-number",y=/\r\n|\r|\n/g;n.hljs?(n.hljs.initLineNumbersOnLoad=r,n.hljs.lineNumbersBlock=l,n.hljs.lineNumbersValue=o,t()):n.console.error("highlight.js not detected!")}(window,document);

/**
 * This reveal.js plugin is wrapper around the highlight.js
 * syntax highlighting library.
 */
(function( root, factory ) {
  if (typeof define === 'function' && define.amd) {
    root.RevealHighlight = factory();
  } else if( typeof exports === 'object' ) {
    module.exports = factory();
  } else {
    // Browser globals (root is window)
    root.RevealHighlight = factory();
  }
}( this, function() {

  // Function to perform a better "data-trim" on code snippets
  // Will slice an indentation amount on each line of the snippet (amount based on the line having the lowest indentation length)
  function betterTrim(snippetEl) {
    // Helper functions
    function trimLeft(val) {
      // Adapted from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/Trim#Polyfill
      return val.replace(/^[\s\uFEFF\xA0]+/g, '');
    }
    function trimLineBreaks(input) {
      var lines = input.split('\n');

      // Trim line-breaks from the beginning
      for (var i = 0; i < lines.length; i++) {
        if (lines[i].trim() === '') {
          lines.splice(i--, 1);
        } else break;
      }

      // Trim line-breaks from the end
      for (var i = lines.length-1; i >= 0; i--) {
        if (lines[i].trim() === '') {
          lines.splice(i, 1);
        } else break;
      }

      return lines.join('\n');
    }

    // Main function for betterTrim()
    return (function(snippetEl) {
      var content = trimLineBreaks(snippetEl.innerHTML);
      var lines = content.split('\n');
      // Calculate the minimum amount to remove on each line start of the snippet (can be 0)
      var pad = lines.reduce(function(acc, line) {
        if (line.length > 0 && trimLeft(line).length > 0 && acc > line.length - trimLeft(line).length) {
          return line.length - trimLeft(line).length;
        }
        return acc;
      }, Number.POSITIVE_INFINITY);
      // Slice each line with this amount
      return lines.map(function(line, index) {
        return line.slice(pad);
      })
        .join('\n');
    })(snippetEl);
  }

  var RevealHighlight = {

    HIGHLIGHT_STEP_DELIMITER: '|',
    HIGHLIGHT_LINE_DELIMITER: ',',
    HIGHLIGHT_LINE_RANGE_DELIMITER: '-',

    init: function() {

      // Read the plugin config options and provide fallbacks
      var config = Reveal.getConfig().highlight || {};
      config.highlightOnLoad = typeof config.highlightOnLoad === 'boolean' ? config.highlightOnLoad : true;
      config.escapeHTML = typeof config.escapeHTML === 'boolean' ? config.escapeHTML : true;

      [].slice.call( document.querySelectorAll( '.reveal pre code' ) ).forEach( function( block ) {

        // Trim whitespace if the "data-trim" attribute is present
        if( block.hasAttribute( 'data-trim' ) && typeof block.innerHTML.trim === 'function' ) {
          block.innerHTML = betterTrim( block );
        }

        // Escape HTML tags unless the "data-noescape" attrbute is present
        if( config.escapeHTML && !block.hasAttribute( 'data-noescape' )) {
          block.innerHTML = block.innerHTML.replace( /</g,"&lt;").replace(/>/g, '&gt;' );
        }

        // Re-highlight when focus is lost (for contenteditable code)
        block.addEventListener( 'focusout', function( event ) {
          hljs.highlightBlock( event.currentTarget );
        }, false );

        if( config.highlightOnLoad ) {
          RevealHighlight.highlightBlock( block );
        }
      } );

    },

    /**
     * Highlights a code block. If the <code> node has the
     * 'data-line-numbers' attribute we also generate slide
     * numbers.
     *
     * If the block contains multiple line highlight steps,
     * we clone the block and create a fragment for each step.
     */
    highlightBlock: function( block ) {

      hljs.highlightBlock( block );

      // Don't generate line numbers for empty code blocks
      if( block.innerHTML.trim().length === 0 ) return;

      if( block.hasAttribute( 'data-line-numbers' ) ) {
        hljs.lineNumbersBlock( block, { singleLine: true } );

        // If there is at least one highlight step, generate
        // fragments
        var highlightSteps = RevealHighlight.deserializeHighlightSteps( block.getAttribute( 'data-line-numbers' ) );
        if( highlightSteps.length > 1 ) {

          // If the original code block has a fragment-index,
          // each clone should follow in an incremental sequence
          var fragmentIndex = parseInt( block.getAttribute( 'data-fragment-index' ), 10 );
          if( typeof fragmentIndex !== 'number' || isNaN( fragmentIndex ) ) {
            fragmentIndex = null;
          }

          // Generate fragments for all steps except the original block
          highlightSteps.slice(1).forEach( function( highlight ) {

            var fragmentBlock = block.cloneNode( true );
            fragmentBlock.setAttribute( 'data-line-numbers', RevealHighlight.serializeHighlightSteps( [ highlight ] ) );
            fragmentBlock.classList.add( 'fragment' );
            block.parentNode.appendChild( fragmentBlock );
            RevealHighlight.highlightLines( fragmentBlock );

            if( typeof fragmentIndex === 'number' ) {
              fragmentBlock.setAttribute( 'data-fragment-index', fragmentIndex );
              fragmentIndex += 1;
            }
            else {
              fragmentBlock.removeAttribute( 'data-fragment-index' );
            }

          } );

          block.removeAttribute( 'data-fragment-index' )
          block.setAttribute( 'data-line-numbers', RevealHighlight.serializeHighlightSteps( [ highlightSteps[0] ] ) );

        }

        RevealHighlight.highlightLines( block );

      }

    },

    /**
     * Visually emphasize specific lines within a code block.
     * This only works on blocks with line numbering turned on.
     *
     * @param {HTMLElement} block a <code> block
     * @param {String} [linesToHighlight] The lines that should be
     * highlighted in this format:
     * "1" 		= highlights line 1
     * "2,5"	= highlights lines 2 & 5
     * "2,5-7"	= highlights lines 2, 5, 6 & 7
     */
    highlightLines: function( block, linesToHighlight ) {

      var highlightSteps = RevealHighlight.deserializeHighlightSteps( linesToHighlight || block.getAttribute( 'data-line-numbers' ) );

      if( highlightSteps.length ) {

        highlightSteps[0].forEach( function( highlight ) {

          var elementsToHighlight = [];

          // Highlight a range
          if( typeof highlight.end === 'number' ) {
            elementsToHighlight = [].slice.call( block.querySelectorAll( 'table tr:nth-child(n+'+highlight.start+'):nth-child(-n+'+highlight.end+')' ) );
          }
          // Highlight a single line
          else if( typeof highlight.start === 'number' ) {
            elementsToHighlight = [].slice.call( block.querySelectorAll( 'table tr:nth-child('+highlight.start+')' ) );
          }

          if( elementsToHighlight.length ) {
            elementsToHighlight.forEach( function( lineElement ) {
              lineElement.classList.add( 'highlight-line' );
            } );

            block.classList.add( 'has-highlights' );
          }

        } );

      }

    },

    /**
     * Parses and formats a user-defined string of line
     * numbers to highlight.
     *
     * @example
     * RevealHighlight.deserializeHighlightSteps( '1,2|3,5-10' )
     * // [
     * //   [ { start: 1 }, { start: 2 } ],
     * //   [ { start: 3 }, { start: 5, end: 10 } ]
     * // ]
     */
    deserializeHighlightSteps: function( highlightSteps ) {

      // Remove whitespace
      highlightSteps = highlightSteps.replace( /\s/g, '' );

      // Divide up our line number groups
      highlightSteps = highlightSteps.split( RevealHighlight.HIGHLIGHT_STEP_DELIMITER );

      return highlightSteps.map( function( highlights ) {

        return highlights.split( RevealHighlight.HIGHLIGHT_LINE_DELIMITER ).map( function( highlight ) {

          // Parse valid line numbers
          if( /^[\d-]+$/.test( highlight ) ) {

            highlight = highlight.split( RevealHighlight.HIGHLIGHT_LINE_RANGE_DELIMITER );

            var lineStart = parseInt( highlight[0], 10 ),
              lineEnd = parseInt( highlight[1], 10 );

            if( isNaN( lineEnd ) ) {
              return {
                start: lineStart
              };
            }
            else {
              return {
                start: lineStart,
                end: lineEnd
              };
            }

          }
          // If no line numbers are provided, no code will be highlighted
          else {

            return {};

          }

        } );

      } );

    },

    /**
     * Serializes parsed line number data into a string so
     * that we can store it in the DOM.
     */
    serializeHighlightSteps: function( highlightSteps ) {

      return highlightSteps.map( function( highlights ) {

        return highlights.map( function( highlight ) {

          // Line range
          if( typeof highlight.end === 'number' ) {
            return highlight.start + RevealHighlight.HIGHLIGHT_LINE_RANGE_DELIMITER + highlight.end;
          }
          // Single line
          else if( typeof highlight.start === 'number' ) {
            return highlight.start;
          }
          // All lines
          else {
            return '';
          }

        } ).join( RevealHighlight.HIGHLIGHT_LINE_DELIMITER );

      } ).join( RevealHighlight.HIGHLIGHT_STEP_DELIMITER );

    }

  }

  Reveal.registerPlugin( 'highlight', RevealHighlight );

  return RevealHighlight;

}));
        
hljs.initHighlightingOnLoad();
</script></body></html>